﻿using System.Text;

// Listing 4-21. Implementacja interfejsów
class Administrator : INamedPerson, ISalariedPerson
{
    public decimal Salary
    {
        get;
        set;
    }
    public string Name
    {
        get
        {
            StringBuilder name = new StringBuilder();
            AppendWithSpace(name, Title);
            AppendWithSpace(name, Forename);
            AppendWithSpace(name, Surname);
            return name.ToString();
        }
    }

    public string Title { get; set; }
    public string Forename { get; set; }
    public string Surname { get; set; }

    void AppendWithSpace(StringBuilder builder, string stringToAppend)
    {
        // Jeśli łańcuch jest pusty, nic nie robimy.
        if (string.IsNullOrEmpty(stringToAppend))
        {
            return;
        }
        // Jeśli jest w nim jakiś tekst, dodajemy odstęp.
        if (builder.Length > 0)
        {
            builder.Append(" ");
        }
        builder.Append(stringToAppend);
    }
}
